package com.asf.cred.struts.action;

/*
 * Generated by MyEclipse Struts
 * Template path: templates/java/JavaClass.vtl
 */

import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.GregorianCalendar;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.upload.FormFile;
import com.nirven.creditos.hibernate.EscritoArchivo;
import com.asf.cred.security.SessionHandler;
import com.asf.cred.struts.form.EscritoForm;
import com.asf.hibernate.mapping.Director;
import com.asf.hibernate.mapping.Menu;
import com.asf.hibernate.mapping.Permiso;
import com.asf.hibernate.mapping.PermisoKey;
import com.asf.hibernate.mapping.Tipificadores;
import com.asf.security.BusinessPersistance;
import com.asf.struts.action.AbmAction;

/**
 * MyEclipse Struts Creation date: 03-25-2008 XDoclet definition:
 * 
 * @struts.action path="/archivo" name="archivoForm" input="/form/archivo.jsp"
 *                scope="request" validate="true"
 */
public class EscritoArchivoAction extends AbmAction {

	public EscritoArchivoAction() {
	}

	/**
	 * Method execute
	 * 
	 * @param mapping
	 * @param form
	 * @param request
	 * @param response
	 * @return ActionForward
	 * @throws Exception
	 */
	@Override
	public ActionForward save(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		BusinessPersistance oBp = SessionHandler.getCurrentSessionHandler()
				.getBusinessPersistance();
		EscritoForm escritoForm = (EscritoForm) form;
		EscritoArchivo escrito = (EscritoArchivo) escritoForm.getEntity();
		FormFile theFile = escritoForm.getTheFile();
		boolean rtaDeletion = false;
		if (!isCancelled(request)) {
			if (theFile.getFileSize() != 0) {
				if (escrito.getArchivo() != null
						&& !escrito.getArchivo().equalsIgnoreCase("")) {
					rtaDeletion = deleteFile(escrito.getArchivo());
				}
				escrito.setArchivo(addTimeMark(theFile.getFileName()));
				String FileName = getSource() + escrito.getArchivo();
				File file = new File(FileName);
				FileOutputStream foStream = new FileOutputStream(file);
				escrito.setMimeType(theFile.getContentType());
				byte[] fileData = theFile.getFileData();
				// guarda los datos del fichero
				ByteArrayOutputStream baos = new ByteArrayOutputStream();
				InputStream stream = theFile.getInputStream();
				byte[] buffer = new byte[8192];
				int bytesLeidos = 0;
				while ((bytesLeidos = stream.read(buffer, 0, 8192)) != -1) {
					baos.write(buffer, 0, bytesLeidos);
				}
				baos.writeTo(foStream);
			} else {
			}
			if (escrito.validate()) {
				ActionMessages actionMessages = new ActionMessages();
				if (escrito.getArchivo() == null || escrito.getNombre().length() == 0) {
					actionMessages.add("EscritoAction.Archivo", new ActionMessage("EscritoAction.Archivo","EscritoAction.Archivo"));
				}
				if (escrito.getNombre() == null || escrito.getNombre().length() == 0) {
					actionMessages.add("EscritoAction.nombre",new ActionMessage("EscritoAction.nombre","EscritoAction.nombre"));
				}
				if (escrito.getTipo() == null || escrito.getTipo().length() == 0) {
					actionMessages.add("EscritoAction.tipo", new ActionMessage("EscritoAction.tipo", "EscritoAction.tipo"));
				}
				if (!actionMessages.isEmpty()) {
					saveErrors(request, actionMessages);
					return mapping.findForward("errorPage");
				}
			}
			boolean isNew = false;
			if (escrito.getId() == null || escrito.getId() == 0)
				isNew = true;
			try {
				oBp.begin();
				oBp.saveOrUpdate(escrito);
				if (isNew) {
					addSubMenu(escrito, oBp);
				} else {
					deletePermisoAndMenu(oBp, escrito);
					addSubMenu(escrito, oBp);
				}
				oBp.commit();
			} catch (Exception e) {
				e.printStackTrace();
				e.getCause().getMessage();
				ActionMessages actionMessages = new ActionMessages();
				actionMessages.add("EscritoAction.execute", new ActionMessage(
						"EscritoAction.execute", "EscritoAction.execute"));
			}
		}
		request.setAttribute("EscritoForm", form);
		return list(mapping, form, request, response);
	}

	public boolean deleteFile(String fileName) {
		boolean rta = false;
		if (fileName != null && !fileName.equalsIgnoreCase("")) {
			String path = getSource() + fileName;
			File f = new File(path);
			if (!f.exists())
				throw new IllegalArgumentException(
						"No se puede eliminar el archivo: " + fileName
								+ "Por que no Existe");
			if (!f.canWrite())
				throw new IllegalArgumentException(
						"Delete: No posee permiso de escritura sobre: "
								+ fileName);
			// If it is a directory, make sure it is empty
			if (f.isDirectory()) {
				String[] files = f.list();
				if (files.length > 0)
					throw new IllegalArgumentException(
							"Delete: Directorio no vacio: " + fileName);
			}
			rta = f.delete();
		}
		return rta;
	}

	public String getSource() {
		String rta = "Escritos";
		List<Director> directores = new ArrayList<Director>();
		BusinessPersistance bp = SessionHandler.getCurrentSessionHandler()
				.getBusinessPersistance();
		String consulta = "SELECT  e  FROM Director e  where e.codigo = '"
				+ rta + "'";
		directores = bp.getByFilter(consulta);
		if (!directores.isEmpty() && directores.get(0) != null) {
			rta = directores.get(0).getValor();
		}
		return rta;
	}

	public String addTimeMark(String name) {
		String rta = "";
		String[] aux = name.split("\\.");
		int lastposition = aux.length;
		GregorianCalendar calendar = new GregorianCalendar();
		for (String string : aux) {
			if (string.equalsIgnoreCase(aux[lastposition - 1])) {
				rta += calendar.getTimeInMillis() + ".";
			}
			rta += string;
		}
		return rta;
	}

	public ActionForward descargar(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		String id = (String) request.getParameter("id");
		OutputStream salida = response.getOutputStream();
		BusinessPersistance oBp = SessionHandler.getCurrentSessionHandler()
				.getBusinessPersistance();
		EscritoArchivo a = (EscritoArchivo) oBp.getById(EscritoArchivo.class,
				new Long(id));
		response.setContentType(a.getMimeType());
		response.setHeader("Content-Disposition", "attachment;filename=\""
				+ a.getNombre() + "\"");
		try {
			String path = getSource() + a.getArchivo();
			// Se abre el fichero original para lectura
			FileInputStream fileInput = new FileInputStream(path);
			BufferedInputStream bufferedInput = new BufferedInputStream(
					fileInput);
			// Bucle para leer de un fichero y escribir en el otro.
			byte[] array = new byte[1000];
			int leidos = bufferedInput.read(array);
			while (leidos > 0) {
				salida.write(array, 0, leidos);
				leidos = bufferedInput.read(array);
			}
			// Cierre de los ficheros
			bufferedInput.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		salida.flush();
		salida.close();
		return null;
	}

	public ActionForward ver(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		String id = (String) request.getParameter("id");
		OutputStream salida = response.getOutputStream();
		BusinessPersistance oBp = SessionHandler.getCurrentSessionHandler()
				.getBusinessPersistance();
		EscritoArchivo a = (EscritoArchivo) oBp.getById(EscritoArchivo.class,
				new Long(id));
		// salida.write(a.getArchivo());
		salida.flush();
		salida.close();
		return null;
	}

	@Override
	public ActionForward delete(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		String id = (String) request.getParameter("entity.id");
		BusinessPersistance oBp = SessionHandler.getCurrentSessionHandler()
				.getBusinessPersistance();
		EscritoArchivo escrito = (EscritoArchivo) oBp.getById(
				EscritoArchivo.class, new Long(id));
		boolean rtaDeletion = true;
		try{
			oBp.begin();
			boolean rta = deleteFile(escrito.getArchivo());
			deletePermisoAndMenu(oBp, escrito);
			oBp.commit();
		}catch (Exception e){
			e.printStackTrace();
			oBp.rollback();
		}
		if (rtaDeletion) {
			super.delete(mapping, form, request, response);
			return list(mapping, form, request, response);
		} else {
			ActionMessages actionMessages = new ActionMessages();
			actionMessages.add("EscritoAction.delete", new ActionMessage(
					"EscritoAction.delete", "EscritoAction.delete"));
			saveErrors(request, actionMessages);
			return mapping.findForward("errorPage");
		}
	}

	private boolean addSubMenu(EscritoArchivo escrito, BusinessPersistance oBp) {
		boolean rta = false;
		String consulta = "From Tipificadores t where t.categoria = 'menu.escrito."
				+ escrito.getTipoStr().toLowerCase() + "'";
		List<Tipificadores> menuContratos = (List<Tipificadores>) oBp
				.getByFilter(consulta);
		String idPa = menuContratos.get(0).getDescripcion();
		Menu newmenu = new Menu();
		newmenu.setIdmodulo(new Long(10));
		newmenu.setNombre(escrito.getNombre());
		newmenu.setRuta("actions/EscritoArchivoAction.do?id="
				+ escrito.getId()+"&do=descargar");
		newmenu.setIsRaiz(new Boolean(false));
		Menu mp = (Menu)oBp.getById(Menu.class, idPa);
		newmenu.setMenu(mp);
		newmenu.setIdpadre(mp.getId());
		newmenu.setActivo(new Long(1));
		newmenu.setTipo(new Long(1));
		newmenu.setAyuda("");
		newmenu.setOrden(null);
		return generarPermiso(newmenu, oBp);
	}

	private boolean generarPermiso(Menu menu, BusinessPersistance oBp) {
		boolean rta = true;
		String consulta = "From Permiso p where p.Menu.id='"
				+ menu.getIdpadre() + "'";
		List<Permiso> permisoAsignar = (List<Permiso>) oBp
				.getByFilter(consulta);
		try {
			oBp.begin();
			oBp.save(menu);
			for (Permiso permiso : permisoAsignar) {
				Permiso newPermiso = new Permiso();
				newPermiso.setMenu(menu);
				PermisoKey key = new PermisoKey();
				key.setCauserk(permiso.getId().getCauserk());
				key.setIdmenu(menu.getIdmenu());
				newPermiso.setId(key);
				newPermiso.setTipo(new Long(2));
				newPermiso.setClave(permiso.getClave());
				oBp.save(newPermiso);
			}
			oBp.commit();
		} catch (Exception e) {
			oBp.rollback();
			e.printStackTrace();
			ActionMessages actionMessages = new ActionMessages();
			actionMessages.add("Escrito.execute", new ActionMessage(
					"Escrito.execute", "Escrito.execute"));

			return false;
		}
		return rta;
	}

	private boolean deletePermisoAndMenu(BusinessPersistance oBp, EscritoArchivo escrito) {
		boolean rta = true;
		String Consulta = "From Menu p where p.ruta = '"
				+ "actions/EscritoArchivoAction.do?id="+ escrito.getId() +"&do=descargar'";
		List<Menu> menues = (List<Menu>) oBp.getByFilter(Consulta);
		for (Menu menuItem : menues) {
			String consultarPermisos = "From Permiso p where p.id.idmenu = '"
					+ menuItem.getId() + "'";
			List<Permiso> permisos = (List<Permiso>) oBp
					.getByFilter(consultarPermisos);
			oBp.delete(permisos);
			oBp.delete(menuItem);
		}
		return rta;
	}
}
